
<p>X-keys input node, sends button or switch events from any or selected attached X-keys. Generates a <code>msg.payload.buttonid </code> from the button pressed, and <code>msg.payload.action</code> with up or down depending on the new state of the button. </p>

 <h3>Properties</h3>
<p>By default this node will send events for any button on any X-keys connected by the USB. By setting these properties the node will only send events matching the desired criteria.</p>
 <li><b>Device:</b> Select from the list the name of specific source X-keys </li>
<li><b>Product ID:</b> A specific PID can be set, usually the device name is sufficient and this can be left to the default.</li>

<li><b>Unit ID:</b> A specific Unit can be selected, this is useful if there are 2 indentical X-keys. Each one can have a different UID if set using the xk Set Unit ID node. </li>
<li><b>Button #:</b> If events from only one specific button are desired then this property can be set. If left to "All" then a switch node can be used to create cases for each button. </li>
<li><b>Action:</b> Select "Up" or "Down" from list. By default a down and up event will be triggered by a button as it  is pressed and released. Often, only the down is of interest.</li>

 

 <h3>Outputs</h3>

     <p><code>msg.payload</code>  An object that contains the compete information from the button event</p>
         <li><code>msg.payload.device</code> is an abbreviated name of the source device e.g. XK12JOG, which represents the XK-12 Jog & Shuttle device
          </li>
         <li><code>msg.payload.pid</code> is the Product ID of the source device e.g. 1062 for the XK-12 Jog & Shuttle device
         </li>
 <li><code>msg.payload.uid</code> is the Unit ID of the source device, typically 0 from the factory but assignable 0-255 using the xk Set Unit ID node
         </li>
<li><code>msg.payload.buttonid</code> is the button number which caused the event
         </li>
<li><code>msg.payload.action</code> is the type of event that occurred. Button events may be either "down" or "up" types
         </li>
     

<h3>Details</h3>
    <p>This node is used to get button or switch closure events from a connected X-keys. Some X-keys have additional features, such as a jog wheel. This node would be used to get the button events, while the analog events would be accessed with the xk jog shuttle node, for example. </p>
    <p>Several filters can be set in the node’s properties to make the node respond to specific X-keys and/or specific buttons and actions. Alternatively, the payload may be passed on to a switch node to branch the flow for each button or device.  </p>
    <p>This node requires the X-keys Server to be installed. X-keys server requires an MQTT broker, which also must be installed.</p>
  

<h3>References</h3>
    <ul>
        <li><a>For a full description of all X-keys products</a> - www.xkeys.com</li>
        <li><a>X-keys server</a> - https://gitlab.com/chris.willing/xkeys-server</li>
    </ul>

